#include <Arduino.h>

class Timer{
private:
	unsigned long _interval, _lastTick;
	void (*_callback)(void);

public:
	Timer(unsigned long interval, void (*callback)(void)){
		_interval = interval;
		_callback = callback;
		_lastTick = millis();
	}

	void loop(){
		unsigned long tick = millis();

		if (tick - _lastTick >= _interval){
			_callback();
			_lastTick = tick;
		}
	}
};