#include <Arduino.h>
#include <ESP8266WiFi.h>
#include <espnow.h>

class Transmitter {
	uint8_t targets[2][6] = {
		{0x50, 0x02, 0x91, 0xEA, 0x3D, 0xFD},
		{0x50, 0x02, 0x91, 0xEA, 0x40, 0x83}};

	unsigned int _targetCount = sizeof(targets) / sizeof(targets[0]);

  public:
	void setup() {
		WiFi.mode(WIFI_STA);

		if (esp_now_init() != 0) {
			Serial.println("Error initializing ESP-NOW");
			return;
		}

		esp_now_set_self_role(ESP_NOW_ROLE_CONTROLLER);
		for (unsigned int i = 0; i < _targetCount; i++) {
			Serial.print("Registering recipient ");
			Serial.print(i);
			Serial.print(": ");
			auto result = esp_now_add_peer(targets[i], ESP_NOW_ROLE_SLAVE, 1, NULL, 0);
			Serial.println(result);
		}
	}

	void send(int value) {
		for (unsigned int i = 0; i < _targetCount; i++) {
			Serial.print("Sending to recipient ");
			Serial.print(i);
			Serial.print(": ");
			auto result = esp_now_send(targets[i], (uint8_t *)&value, sizeof(value));
			Serial.println(result);
		}
	}
};